<?php
	require_once 'app/bootstrap.php';
	umask(0);
	$bootstrap = \Magento\Framework\App\Bootstrap::create(BP, $_SERVER);
	$bootstrap->createApplication('Magento\Framework\App\Http');
	$objectManager = \Magento\Framework\App\ObjectManager::getInstance();

	$moduleList = $objectManager->create('Magento\Framework\Module\ModuleList');

	$modules = [];
	foreach($moduleList->getAll() as $moduleName => $module) {
        if ( strpos($moduleName, 'Plumrocket_') !== false) {
            $modules[$moduleName] = $module;
        }
    }
    unset($moduleName);

    $modulesCount = count($modules);
?>
<!DOCTYPE html>
<html>
<head>
	<title>Remove Plumrocket Extensions for Magento 2</title>
</head>
<body>
	<center>
<?php if (empty($_POST['module'])) { ?>
	<?php if ($modulesCount) { ?>
		<h2>Remove Plumrocket Inc. extensions for Magento 2.</h2>
		<form method="post">
			<table cellspacing="5" cellpadding="5">
				<tr>
					<td><strong>Module Name</strong></td>
					<td><strong>Action</strong></td>
				</tr>
				<?php foreach($modules as $moduleName => $module) { ?>
					<?php if ($modulesCount > 1 && $moduleName == 'Plumrocket_Base') continue; ?>
					<tr>
						<td><?php echo $moduleName ?> v<?php echo $module['setup_version'] ?></td>
						<td><button type="submit" name="module" value="<?php echo $moduleName ?>" />Remove</button></td>
					</tr>
			    <?php } ?>
		    </table>
		</form>
	<?php } else { ?>
		<h2>None of Plumrocket Inc. extensions for Magento 2 is installed.</h2>
	<?php } ?>
<?php } else {
	try {

		foreach($modules as $name => $module) {
			if ($name == $_POST['module']) {
				$moduleVersion = $module['setup_version'];
				$moduleName = $name;
				break;
			}
		}

		if (empty($moduleName)) {
			throw new \Exception("Extension not found.", 1);
		}

		$uninstall = $objectManager->create(str_replace('_', '\\', $moduleName).'\Setup\Uninstall');

		$appResource = $objectManager->get('Magento\Framework\App\ResourceConnection');
		$setup = new \Magento\Setup\Module\Setup($appResource);
		$context = new \Magento\Setup\Model\ModuleContext($moduleVersion);

		$uninstall->uninstall($setup, $context);

		echo '<h2 style="color:green;">Extension removed successfully.</h2>';
	} catch (\Exception $e) {
		echo '<h2 style="color:red;">Error:<br/> ' . $e->getMessage() . '</h2>';
	}

	?>
		<form method="post" action="?<?php echo time() ?>">
			<button type="submit" /> &lt;&lt; Back</button>
		</form>
	<?php
}
?>
	<br/>
	<br/>
	<h4 style="color:red;">Attention! After you uninstalled the needed extension(s) - please remove this script from your server.</h4>
	</center>
</body>
</html>